package generator.shikaku;

import java.awt.Point;
import java.util.ArrayList;

import solver.SolverController;
import solver.shikaku.Rect;
import solver.shikaku.ShikakuResult;
import solver.shikaku.ShikakuSolverImpl;


public class ShikakuGeneratorImpl implements SolverController {
	
	private ArrayList list = new ArrayList();
	
	private ShikakuSolverImpl firstSolver;
	
	private ShikakuSolverImpl lastSolver;
	
	private ArrayList resultList = new ArrayList();
	
	private ShikakuResult result = null;
	
	private String errMessage = null;
	
	private SolverController solverController = new SolverController() {

		public void addResult(Object result) {
			resultList.add(result);
		}

		public boolean isReturn() {
			return resultList.size() >= 2;
		}
	};
	
	public ShikakuGeneratorImpl(int width, int height) {
		firstSolver = new ShikakuSolverImpl(width, height);
		lastSolver = new ShikakuSolverImpl(width, height);
	}
	
	/**
	 * lݒ肵܂
	 * 
	 * @param x wW
	 * @param y xW
	 * @param number l
	 */
	public void setNumber(int x, int y, int number) {
		firstSolver.setNumber(x, y, number);
		if (number < 0) {
			list.add(new Point(x, y));
		}
	}
	
	/**
	 * s
	 * 
	 * @throws InterruptedException
	 */
	public int start() throws InterruptedException {
		
		int size = list.size();
		if (size <= 1) {
			errMessage = "m݂̐܂";
			return INPUTERROR;
		}
		
		//\o[̏s܂
		int ret = firstSolver.init();
		
		if (ret == PROCESS) {
			//܂AċAȂŉ߂܂
			resultList.clear();
			ret = firstSolver.solve(solverController, 1, false);
			if (ret == MULTI) {
				//ɂǂ܂łċAsẢ߂܂
				ShikakuSolverImpl deepSolver = new ShikakuSolverImpl(firstSolver);
			
				//g addResult Ăł炤̂ړI
				ret = deepSolver.solve(this, 1, true);
			} else if (ret == COMPLATE) {
				//łɖƂĊĂ܂
				result = (ShikakuResult)resultList.get(0);
			} else if (ret == NORESULT) {
				//܂
				errMessage = "݂܂";
				return NORESULT;
			}
			
			if (result != null) {
				return COMPLATE;
			} else if (ret == NORESULT) {
				errMessage = "݂܂";
				return NORESULT;
			} else {
				errMessage = "ӉƂȂ肪݂܂BiЂƂMpłȂj";
				return NORESULT;
			}
			
		} else {
			//G[ł
			errMessage = "͂ɃG[܂";
			return INPUTERROR;
		}
	}

	public void addResult(Object obj) throws InterruptedException {
		
		
		//쐬AꂪPǂ`FbN܂
		ShikakuResult result = (ShikakuResult)obj;
		
		int size = list.size();
		lastSolver.copy(firstSolver);
		for (int i = 0; i < size; ++i) {
			Point point = (Point)list.get(i);
			int board = firstSolver.getBoard(point.x, point.y) - 1;
			Rect rect = result.getRect(board);
			lastSolver.changeRectNumber(board, rect.area);
		}
		
		resultList.clear();
		
		int ret = lastSolver.solve(solverController, 1, false);
		if (ret == COMPLATE) {
			this.result = (ShikakuResult)resultList.get(0);
		}
	}

	public boolean isReturn() {
		return result != null;
	}

	public String getErrMessage() {
		return errMessage;
	}

	public ShikakuResult getResult() {
		return result;
	}
}
