package pencilbox.shikaku;

import generator.shikaku.ShikakuGeneratorImpl;
import pencilbox.common.core.BoardBase;
import pencilboxex.GeneratorBase;
import solver.SolverConst;
import solver.shikaku.Rect;
import solver.shikaku.ShikakuResult;

public class Generator extends GeneratorBase {

	private ShikakuResult sikakuResult = null;
	
	public void generate(BoardBase puzzleBoard) throws InterruptedException {
		
		Board board = (Board)puzzleBoard;
		int width = board.cols();
		int height = board.rows();
		int area = width * height;
		
		ShikakuGeneratorImpl generatorImpl = new ShikakuGeneratorImpl(width, height);
		
		//̑a
		int sum = 0;
		int count = 0;
		
		//ɒlݒ肵܂
		for (int y = 0; y < height; ++y) {
			for (int x = 0; x < width; ++x) {
				int s = board.getNumber(y, x);
				
				if (s < 0) {
					sum += 1;
					++count;
					generatorImpl.setNumber(x, y, s);
				}
				if (s > 0) {
					sum += s;
					generatorImpl.setNumber(x, y, s);
				}
			}
		}
		
		//l`FbN
		if (sum == 0) {
			setErrMessage("͂Ă܂");
		} else if (count == 0) {
			setErrMessage("m݂̐܂");
		} else if (sum > area) {
			setErrMessage("̑aʐς傫ł");
		}
		
		if (generatorImpl.start() == SolverConst.COMPLATE) {
			sikakuResult = generatorImpl.getResult();
		} else {
			setErrMessage(generatorImpl.getErrMessage());
		}
	}

	public void updateBoard(BoardBase puzzleBoard) {
		
		if (puzzleBoard != null) {
			Board board = (Board)puzzleBoard;
			int count = sikakuResult.count();
			int historyCount = sikakuResult.getHistoryCount();
			
			board.clearBoard();
			if (historyCount == 0) {
				for (int i = 0; i < count; ++i) {
					Rect rect = sikakuResult.getRect(i);
					
					//lp쐬
					board.addSquare(new Square(rect.top, rect.left, rect.bottom, rect.right));
				}
			} else {
				for (int i = 0; i < historyCount; ++i) {
					Rect rect = sikakuResult.getHistory(i);
					Square square = null;
					Square newSquare = new Square(rect.top, rect.left, rect.bottom, rect.right);
					
					label:
					for (int y = rect.top; y <= rect.bottom; ++y) {
						for (int x = rect.left; x <= rect.right; ++x) {
							square = board.getSquare(y, x);
							if (square != null) {
								break label;
							}
						}
					}
					
					if (square == null) {
						//lp쐬
						board.addSquareA(newSquare);
					} else {
						if ((square.c0() == rect.left || square.c1() == rect.right)
								&& (square.r0() == rect.top || square.r1() == rect.bottom)) {
							board.changeSquareA(square, newSquare);
						} else {
							board.removeSquareA(square);
							board.addSquareA(newSquare);
						}
					}
				}
			}
			int width = board.cols();
			int height = board.rows();
			for (int y = 0; y < height; ++y) {
				for (int x = 0; x < width; ++x) {
					int s = board.getNumber(y, x);
					
					if (s < 0) {
						Square square = board.getSquare(y, x);
						board.setNumber(y, x, square.getSquareSize());
					}
				}
			}
		}
	}
}
