package pencilbox.shikaku;


import pencilbox.common.core.BoardBase;
import pencilboxex.SolverBase;
import solver.shikaku.Rect;
import solver.shikaku.ShikakuResult;
import solver.shikaku.ShikakuSolverImpl;

/**
 * lpɐ؂̃\o[NX
 */
public class Solver extends SolverBase {
	
	/**  */
	private ShikakuResult sikakuResult = null;
	
	/**
	 * 𓚂Ȃ
	 * 
	 * @param board Ֆ
	 */
	public int solveProblem(BoardBase puzzleBoard) throws InterruptedException {
		
		Board board = (Board)puzzleBoard;
		int width = board.cols();
		int height = board.rows();
		int area = width * height;
		
		ShikakuSolverImpl solverImpl = new ShikakuSolverImpl(width, height);
		
		//̑a
		int sum = 0;
		
		//\o[ɒlݒ肵܂
		for (int y = 0; y < height; ++y) {
			for (int x = 0; x < width; ++x) {
				int s = board.getNumber(y, x);
				
				if (s < 0) {
					sum += 1;
					solverImpl.setNumber(x, y, s);
				}
				if (s > 0) {
					sum += s;
					solverImpl.setNumber(x, y, s);
				}
			}
		}
		
		//l`FbN
		if (sum == 0) {
			setErrMessage("͂Ă܂");
			return INPUTERROR;
		} else if (sum > area) {
			setErrMessage("̑aʐς傫ł");
			return INPUTERROR;
		}
		
		int result = solverImpl.start(this);
		
		switch (result) {
		case COMPLATE:
			//\o[Ֆʂɒlݒ肵܂
			sikakuResult = (ShikakuResult)getResult();
			break;
		case MULTI:
			//\o[Ֆʂɒlݒ肵܂
			sikakuResult = solverImpl.getResult();
			break;
		}
		
		return result;
	}

	/**
	 * ʂՖʂɔf܂
	 * 
	 * @param puzzleBoard Ֆ
	 * @see com.nikoli.pencilbox.NikolicomSolverBase#updateBoard(pencilbox.common.core.BoardBase)
	 */
	public void updateBoard(BoardBase puzzleBoard) {

		if (puzzleBoard != null) {
			Board board = (Board)puzzleBoard;
			int count = sikakuResult.count();
			int historyCount = sikakuResult.getHistoryCount();
			
			board.clearBoard();
			if (historyCount == 0) {
				for (int i = 0; i < count; ++i) {
					Rect rect = sikakuResult.getRect(i);
					
					//lp쐬
					board.addSquare(new Square(rect.top, rect.left, rect.bottom, rect.right));
				}
			} else {
				for (int i = 0; i < historyCount; ++i) {
					Rect rect = sikakuResult.getHistory(i);
					Square square = null;
					Square newSquare = new Square(rect.top, rect.left, rect.bottom, rect.right);
					
					label:
					for (int y = rect.top; y <= rect.bottom; ++y) {
						for (int x = rect.left; x <= rect.right; ++x) {
							square = board.getSquare(y, x);
							if (square != null) {
								break label;
							}
						}
					}
					
					if (square == null) {
						//lp쐬
						board.addSquareA(newSquare);
					} else {
						if ((square.c0() == rect.left || square.c1() == rect.right)
								&& (square.r0() == rect.top || square.r1() == rect.bottom)) {
							board.changeSquareA(square, newSquare);
						} else {
							board.removeSquareA(square);
							board.addSquareA(newSquare);
						}
					}
				}
			}
		}
	}
}
