package pencilboxex;

import pencilbox.common.core.PencilBoxException;
import pencilbox.common.factory.ClassUtil;
import pencilbox.common.factory.Constants;
import pencilbox.common.factory.PencilBoxClassException;
import pencilbox.common.gui.MenuCommand;

/**
 * gj[R}h
 */
public class MenuCommandEx extends MenuCommand {
	
	//TuNXނ݂₽ɍ̂͂܂萫ɍȂ̂
	//MenuȊŐʕ̔h͂̃NXɏW
	/** \o[̃NX */
	private static final String SOLVER_CLASS = "Solver";
	/** \o[̃NX */
	private static final String GENERATOR_CLASS = "Generator";
	
	
	
	
	/**
	 * t[^Cgݒ肷
	 * ҏW̃pY̎ނƃt@C\
	 */
	protected void setFrameTitle() {
		getFrame().setTitle(getProblem().getFileName() + " - " + getPencilType().getTitle() + " - " + Constants.TITLE);
	}

	/**
	 * \o[Nł邩ǂԂ
	 */
	public boolean isSolverSupported() {
		
		//Lb`̂߂ǂ̂Ŏ蔲
		try {
			ClassUtil.createInstance(getPencilType(), SOLVER_CLASS);
		} catch (PencilBoxClassException e) {
			return false;
		}
		
		return true;
	}
	
	/**
	 * \o[N
	 */
	public void launchSolver() {
		
		try {
			SolverBase solver = (SolverBase) ClassUtil.createInstance(
					getPencilType(), SOLVER_CLASS);
			
			SolverDialog.start(getFrame(), solver, getProblem().getBoard());
			
		} catch (PencilBoxException e) {
			showErrorMessage(e);
		}
	}
	
	/**
	 * Nł邩ǂԂ
	 */
	public boolean isGeneratorSupported() {
		
		//Lb`̂߂ǂ̂Ŏ蔲
		try {
			ClassUtil.createInstance(getPencilType(), GENERATOR_CLASS);
		} catch (PencilBoxClassException e) {
			return false;
		}
		
		return true;
	}
	
	/**
	 * \o[N
	 */
	public void launchGenerator() {
		
		try {
			GeneratorBase generator = (GeneratorBase) ClassUtil.createInstance(
					getPencilType(), GENERATOR_CLASS);
			
			GeneratorDialog.start(getFrame(), generator, getProblem().getBoard());
			
		} catch (PencilBoxException e) {
			showErrorMessage(e);
		}
	}
}
