package pencilboxex;

import java.awt.event.InputEvent;

import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import pencilbox.common.gui.MenuBase;

/**
 * gj[NX
 */
public class MenuExBase extends MenuBase {
	
	/** [\o[N]j[ACe */
	private JMenuItem launchSolverItem;
	
	/** [N]j[ACe */
	private JMenuItem launchGeneratorItem;
	
	/**
	 * [ҏW]j[ɒǉƎj[쐬
	 * <p>
	 * KvɉĊeTuNXŃI[o[ChB
	 * eTuNXł́A
	 * <ul>
	 * <li>addSeparatorToEditMenu()</li>
	 * <li>addToEditMenu(JMenuItem)</li>
	 * </ul>
	 * pēƎj[ǉB
	 * </p>
	 */
	protected void buildExtentionEditMenu() {
		super.buildExtentionEditMenu();
		boolean add = false;
		if (isSolverSupported()) {
			addToEditMenu(launchSolverItem = makeCommandMenuItem("\o[N(L)", 'L'));
			add = true;
		}
		if (isGeneratorSupported()) {
			addToEditMenu(launchGeneratorItem = makeCommandMenuItem("N(G)", 'G'));
			add = true;
		}
		if (add) {
			addSeparatorToEditMenu();
		}
	}
	
	/**
	 * ǂ̃j[IꂽׂāCΉR}hNB
	 * eTuNXŃI[o[ChB
	 * @param target Iꂽj[
	 */
	public void executeCommand(JMenuItem target) {
		if (target == launchSolverItem) {
			launchSolver();
		} else if (target == launchGeneratorItem) {
			launchGenerator();
		} else {
			super.executeCommand(target);
		}
	}
	
	/**
	 * [ҏW]-[\o[N]
	 */
	protected void launchSolver() {
		getMenuCommandEx().launchSolver();
	}
	
	/**
	 * [ҏW]-[\o[N]T|[g邩ǂ擾
	 * 
	 * @return [ҏW]-[\o[N]T|[g邩ǂ
	 */
	protected boolean isSolverSupported() {
		return getMenuCommandEx().isSolverSupported();
	}
	
	/**
	 * [ҏW]-[N]
	 */
	protected void launchGenerator() {
		getMenuCommandEx().launchGenerator();
	}
	
	/**
	 * [ҏW]-[N]T|[g邩ǂ擾
	 * 
	 * @return [ҏW]-[N]T|[g邩ǂ
	 */
	protected boolean isGeneratorSupported() {
		return getMenuCommandEx().isGeneratorSupported();
	}
	
	/**
	 * 
	 * @see pencilbox.common.gui.MenuBase#setAccelerators()
	 */
	protected void setAccelerators() {
		super.setAccelerators();
		if (launchSolverItem != null) {
			launchSolverItem.setAccelerator(
					KeyStroke.getKeyStroke('L',	InputEvent.CTRL_MASK | InputEvent.ALT_MASK));
		}
		if (launchGeneratorItem != null) {
			launchGeneratorItem.setAccelerator(
					KeyStroke.getKeyStroke('G',	InputEvent.CTRL_MASK | InputEvent.ALT_MASK));
		}
	}
	
	/**
	 * gj[R}h擾
	 * 
	 * @return j[R}h
	 */
	protected MenuCommandEx getMenuCommandEx() {
		
		return (MenuCommandEx)getMenuCommand();
	}
}
