package pencilboxex;

import java.util.ArrayList;


import pencilbox.common.core.BoardBase;
import solver.SolverController;

/**
 * \o[̊NX
 */
public abstract class SolverBase implements SolverController {
	
	/** _CAO */
	private SolverDialog dialog = null;
	/** 𓚂̃Xg */
	private ArrayList resultList = new ArrayList();
	
	
	/**
	 * 𓚂Ȃ
	 * 
	 * @param board Ֆ
	 * @return 
	 * @throws InterruptedException ̃\bhsĂXbhfꂽꍇ
	 */
	public abstract int solveProblem(BoardBase board) throws InterruptedException;
	
	
	/**
	 * 
	 * @param board
	 */
	public abstract void updateBoard(BoardBase board);
	
	/**
	 * bZ[Wݒ肷
	 * 
	 * @param message bZ[W
	 */
	public void setMessage(String message) {
		if (dialog != null) {
			dialog.setMessage(message);
		}
	}
	
	/**
	 * G[bZ[Wݒ肷
	 * 
	 * @param message bZ[W
	 */
	protected void setErrMessage(String string) {
		if (dialog != null) {
			dialog.setErrMessage(string);
		}
	}

	/**
	 * _CAO擾
	 * 
	 * @return _CAO
	 */
	public SolverDialog getDialog() {
		return dialog;
	}
	
	/**
	 * _CAOݒ肷
	 * 
	 * @param dialog _CAO
	 */
	public void setDialog(SolverDialog dialog) {
		this.dialog = dialog;
	}
	
	/**
	 * 𓚂ǉ
	 * 
	 * @param result 
	 * @see com.nikoli.solver.SolverController#addResult(java.lang.Object)
	 */
	public void addResult(Object result) {
		if (!resultList.contains(result)) {
			resultList.add(result);
			setMessage("𓚐F" + resultList.size());
		}
	}

	/**
	 * 𓚂Ԃ
	 * 
	 * @return 
	 */
	public Object getResult() {
		
		if (resultList.size() >= 1) {
			return resultList.get(0);
		}
		return null;
	}
	
	/**
	 * 𓚂߂邩ǂԂ
	 * 
	 * @return 𓚂߂邩ǂ
	 * @see com.nikoli.solver.SolverController#isReturn()
	 */
	public boolean isReturn() {
	
		return resultList.size() > 1;
	}
}
