package pencilboxex;

import java.awt.event.ActionListener;
import java.lang.reflect.InvocationTargetException;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

import pencilbox.common.core.BoardBase;
import pencilbox.common.gui.Frame;
import solver.SolverConst;

/**
 * \o[NA~ʕ\ȂǂT|[g_CAO
 */
public final class SolverDialog extends TaskDialog implements ActionListener, Runnable, SolverConst {
	
	/** ^Cg */
	private static final String TITLE = "\o[";

	/** \o[ */
	private SolverBase solver = null;
	/** Ֆ */
	private BoardBase board = null;
	/**  */
	private int result = CANCEL;
	
	/**
	 * \o[N̈A̗s
	 * 
	 * @param frame _CAO̐et[
	 * @param solver \o[
	 * @param board Ֆ
	 * @return 
	 */
	public static int start(final Frame frame, final SolverBase solver, final BoardBase board) {
		SolverDialog dialog = new SolverDialog(frame, solver, board);
		
		solver.setDialog(dialog);
		
		dialog.pack();
		dialog.setLocationRelativeTo(frame);
		
		dialog.start();
		
		if (dialog.thread != null) {
			dialog.setVisible(true);
		}
		
		//
		int result = dialog.result;
		
		switch (result) {
		case COMPLATE:
			JOptionPane.showMessageDialog(frame, "B݂܂", TITLE, JOptionPane.INFORMATION_MESSAGE);
			break;
		case INPUTERROR:
			JOptionPane.showMessageDialog(frame, "̓G[F" + dialog.getErrMessage(), TITLE, JOptionPane.ERROR_MESSAGE);
			break;
		case NORESULT:
			JOptionPane.showMessageDialog(frame, "݂܂", TITLE, JOptionPane.WARNING_MESSAGE);
			break;
		case MULTI:
			JOptionPane.showMessageDialog(frame, "݂܂", TITLE, JOptionPane.WARNING_MESSAGE);
			break;
		}
		
		return result;
	}
	
	/**
	 * RXgN^
	 * 
	 * @param frame _CAO̐et[
	 * @param solver \o[
	 * @param board Ֆ
	 */
	private SolverDialog(Frame frame, SolverBase solver, BoardBase board) {
		super(frame, TITLE, true);
		this.solver = solver;
		this.board = board;
		setText("𓚒");
	}
	
	/**
	 * XbhN
	 */
	public void start() {
		
		thread = new Thread(this);
		
		thread.start();
	}
	
	/**
	 * \o[NAIʂ
	 */
	public void run() {
		
		//lLZƂ
		result = CANCEL;
		try {
			long time = System.nanoTime();
			result = solver.solveProblem(board);
			try {
				SwingUtilities.invokeAndWait(new Runnable() {
					public void run() {
						solver.updateBoard(board);
					}
				});
			} catch (InvocationTargetException e) {
			}
			System.out.println(((System.nanoTime() - time) / 1000000) + "ms");
			getFrame().repaint();
		} catch (InterruptedException e) {
			//ꉞI
			result = CANCEL;
		} catch (RuntimeException e) {
			e.printStackTrace();
			setErrMessage(e.toString());
			result = SolverConst.INPUTERROR;
		} finally {
			synchronized (this) {
				thread = null;
				//ʂ
				setVisible(false);
			}
		}
	}
}
