package pencilboxex;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import pencilbox.common.gui.Frame;


public abstract class TaskDialog extends JDialog implements ActionListener, Runnable {

	/** _CAO̐et[ */
	private Frame frame;
	/** x */
	private JLabel label = new JLabel("s");
	/** bZ[Wx */
	private JLabel messageLabel = new JLabel(" ");
	/** {^ */
	private JButton button = new JButton("~");
	/** G[bZ[W */
	private String errMessage = "";
	
	/** Xbh */
	protected Thread thread = null;
	
	public TaskDialog(Frame frame, String title, boolean modal) {
		super(frame, title, modal);
		this.frame = frame;
		
		getContentPane().setLayout(new BorderLayout());
		JPanel panel = new JPanel(new BorderLayout());
		JPanel labelPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		
		panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		messageLabel.setBorder(BorderFactory.createLoweredBevelBorder());
		
		labelPanel.add(label);
		panel.add(labelPanel, BorderLayout.CENTER);
		buttonPanel.add(button);
		panel.add(buttonPanel, BorderLayout.SOUTH);
		getContentPane().add(panel, BorderLayout.CENTER);
		getContentPane().add(messageLabel, BorderLayout.SOUTH);
		
		button.addActionListener(this);
	}
	
	/**
	 * XbhN
	 */
	public void start() {
		
		thread = new Thread(this);
		
		thread.start();
	}

	/**
	 * ANVCxg
	 * 
	 * @param e ANVCxg
	 */
	public void actionPerformed(ActionEvent e) {

		if (e.getSource() == button) {
			synchronized (this) {
				if (thread != null) {
					thread.interrupt();
				}
			}
		}
	}
	
	/**
	 * bZ[Wݒ肷
	 * 
	 * @param message bZ[W
	 */
	public void setText(String message) {
		label.setText(message);
	}
	
	/**
	 * bZ[Wݒ肷
	 * 
	 * @param message bZ[W
	 */
	public void setMessage(String message) {
		messageLabel.setText(message);
	}
	
	/**
	 * G[bZ[W擾
	 * 
	 * @return G[bZ[W
	 */
	public String getErrMessage() {
		return errMessage;
	}

	/**
	 * G[bZ[Wݒ肷
	 * 
	 * @param errMessage G[bZ[W
	 */
	public void setErrMessage(String errMessage) {
		this.errMessage = errMessage;
	}
	
	public Frame getFrame() {
		return frame;
	}
}
