package solver.shikaku;

import java.util.ArrayList;

import solver.SolverController;


/**
 * \o[̎Ԃ̃NX
 */
public final class ShikakuSolverImpl implements ShikakuSolver {
	
	/**  */
	private final int width;
	/**  */
	private final int height;
	
	/** Ֆʁiɓ`̃CfbNXێ܂j */
	private final int[] board;
	/** `FbNpՖ */
	private final int[] checkboard;
	/** `FbNtO */
	private boolean check = false;
	/** ǉ̋`i[郊Xgiǉɂ̂ݍ쐬FJnnullj */
	private ArrayList rectList = null;
	/** `̔zi`𑀍삷ۂɂ͂p܂j */
	private Rect[] rectArray = null;
	
	/** m肳ĂȂɗp邱Ƃ̂ł邠܂̐ */
	private int least = 0;
	/** m肳ĂȂ̐ */
	private int undecidedCount = 0;
	
	/**  */
	private final ArrayList history = new ArrayList();
	
	/** q̃CX^X */
	//KvɂȂ܂ō쐬Axg܂킷
	private ShikakuSolverImpl child = null;
	
	/***/
	private ArrayList resultList;
	
	/**
	 * RXgN^
	 * 
	 * @param width Ֆʂ̕B1ł邱
	 * @param height Ֆʂ̍B1ł邱
	 */
	public ShikakuSolverImpl(final int width, final int height) {
		if (width <= 0) {
			throw new IllegalArgumentException();
		}
		if (height <= 0) {
			throw new IllegalArgumentException();
		}
		
		this.width = width;
		this.height = height;
		final int area = width * height;
		this.board = new int[area];
		//̈̂ݐ
		this.checkboard = new int[area];
		
		this.resultList = new ArrayList();
	}
	
	/**
	 * Rs[RXgN^
	 * 
	 * @param impl Rs[
	 */
	public ShikakuSolverImpl(final ShikakuSolverImpl impl) {
		if (impl == null) {
			throw new NullPointerException();
		}
		//Pɓ]LĂ悢̂]L
		this.width = impl.width;
		this.height = impl.height;
		this.undecidedCount = impl.undecidedCount;
		//Rs[ׂ̂͗̈𐶐
		this.board = new int[impl.board.length];
		//̈̂ݐ
		this.checkboard = new int[impl.checkboard.length];
		
		copy(impl);
	}
	
	/**
	 * Rs[s܂
	 * 
	 * @param impl Rs[
	 */
	public void copy(final ShikakuSolverImpl impl) {
		if (impl == null) {
			throw new NullPointerException();
		}
		this.least = impl.least;
		for (int i = 0; i < board.length; ++i) {
			this.board[i] = impl.board[i];
		}
		//impl.rectListnullłƑz
		final ArrayList sourceList = impl.rectList;
		if (sourceList != null) {
			final int size = sourceList.size();
			final ArrayList rectList = new ArrayList(size);
			for (int i = 0; i < size; ++i) {
				rectList.add(sourceList.get(i));
			}
			this.rectList = rectList;
		} else {
			this.rectList = null;
		}
		final Rect[] sourceArray = impl.rectArray;
		if (sourceArray != null) {
			final int size = sourceArray.length;
			final Rect[] rectArray;
			if (this.rectArray != null && this.rectArray.length != size) {
				rectArray = this.rectArray;
			} else {
				rectArray = new Rect[size];
			}
			for (int i = 0; i < size; ++i) {
				rectArray[i] = sourceArray[i];
			}
			this.rectArray = rectArray;
		} else {
			this.rectArray = null;
		}
		history.clear();
		history.addAll(impl.history);
		resultList = impl.resultList;
	}
	
	/**
	 * lݒ肵܂
	 * 
	 * @param x wW
	 * @param y xW
	 * @param number l
	 */
	public void setNumber(int x, int y, int number) {
		
		if (rectList == null) {
			rectList = new ArrayList();
		}
		
		int index = y * width + x;
		
		if (board[index] != 0) {
			throw new IllegalStateException();
		}
		
		board[index] = rectList.size() + 1;
		rectList.add(new Rect(x, y, number));
	}
	
	/**
	 * 𓚂s
	 * 
	 * @throws InterruptedException
	 */
	public int start(SolverController controller) throws InterruptedException {
		
		int ret = init();
		
		if (ret == PROCESS) {
			ret = solve(controller, 0, true);
		}
		
		return ret;
	}

	public int init() {

		if (rectList == null) {
			return MULTI;
		}
		
		//Xgzɓ]L
		final int size = rectList.size();
		//̑a
		int sum = 0;
		
		rectArray = new Rect[size];
		undecidedCount = 0;
		int undecidedIndex = 0;
		
		for (int i = 0; i < size; ++i) {
			Rect rect = (Rect)rectList.get(i);
			int number = rect.number;
			
			if (number > 0) {
				sum += number;
			} else {
				sum += 1;
				++undecidedCount;
				undecidedIndex = i;
			}
			rectArray[i] = rect;
			if (rect.number == 1) {
				history.add(rect);
			}
		}
		
		rectList = null;
		
		least = (width * height) - sum;
		
		if (least < 0) {
			return NORESULT;
		}
		
		if (undecidedCount == 1) {
			//̒l1̏ꍇAm̐least + 1ɂ܂
			Rect rect = rectArray[undecidedIndex]; 
			rectArray[undecidedIndex] = new Rect(rect.left, rect.top, least + 1);
			undecidedCount = 0;
			least = 0;
		} else if (least == 0) {
			if (undecidedCount > 0) {
				for (int i = 0; i < rectArray.length; ++i) {
					Rect rect = rectArray[i];
					if (rect.number < 0) {
						rectArray[i] = new Rect(rect.left, rect.top, 1);
					}
				}
				undecidedCount = 0;
			}
		}
		
		return PROCESS;
	}
	
	/**
	 * 𓚂s
	 * 
	 * @param controller
	 * @param level ݂̉̒i
	 * @param deep یȂsǂ
	 * @return
	 */
	public int solve(SolverController controller, int level, boolean deep) throws InterruptedException {
		
		if (least != 0 && undecidedCount == 0) {
			//̐ȂȂaʐςɖȂꍇA
			//ɑ΂鏈s܂
			//}Xɓlp̐
			while (true) {
				Thread.sleep(1);
				check = false;
				//lpK}X̃`FbNs܂
				for (int i = 0; i < rectArray.length; ++i) {
					int ret = checkRect(i);
					if (ret != 0) {
						if (ret > 0) {
							check = true;
						} else {
							return NORESULT;
						}
					}
				}
				if (check) continue;
				break;
			}
			return MULTI;
		} else {
			//̃WbNŌ̏
			//int result = NORESULT;
			
			mainloop:
			while (true) {
				Thread.sleep(1);
				check = false;
				//Ń`FbNpՖʂ̏s
				for (int i = 0; i < checkboard.length; ++i) {
					checkboard[i] = 0;
				}
				//lpK}X̃`FbNs܂
				for (int i = 0; i < rectArray.length; ++i) {
					int ret = checkRect(i);
					if (ret != 0) {
						if (ret > 0) {
							check = true;
						} else {
							return NORESULT;
						}
					}
				}
				if (check) continue;
				//̃}X܂ނƂ̂łlp̃`FbNs܂
				if (undecidedCount > 0) {
					//̐肤}X`FbN܂
					for (int i = 0; i < rectArray.length; ++i) {
						checkUndecidedRect(i);
					}
				}
				//̃}Xɓlp1ȂƂ낪邩ǂ`FbN܂
				int count = Integer.MIN_VALUE;
				int firstX = -1;
				int firstY = -1;
				//łɂׂẴ}X܂ǂ̃`FbNs܂
				for (int y = 0; y < height; ++y) {
					for (int x = 0; x < width; ++x) {
						int index = y * width + x;
						
						if (board[index] == 0) {
							int value = checkboard[index];
							if (value > 0) {
								//`̓_܂ނ悤ɕύX
								if (changeRect(value - 1, x, y)) {
									check = true;
								} else {
									return NORESULT;
								}
							} else if (value == 0) {
								return NORESULT;
							} else if (count < value) {
								count = value;
								firstX = x;
								firstY = y;
							}
						}
					}
				}
				if (check) continue;
				
				if (firstY < 0) {
					//ŃUgݒ
					//ŖYꂽ`qXg[ɒǉ
					for (int i = 0; i < rectArray.length; ++i) {
						if (rectArray[i].area == 1) {
							history.add(rectArray[i]);
						}
					}
					ShikakuResult result = getResult();
					if (!resultList.contains(result)) {
						resultList.add(result);
						controller.addResult(result);
					}
					return COMPLATE;
				}
				
				//x0ȉ̏ꍇASm}Xɑ΂ĉs܂
				if (level <= 0) {
					//菈s܂
					for (int y = 0; y < height; ++y) {
						for (int x = 0; x < width; ++x) {
							int index = y * width + x;
							if (checkboard[index] < 0) {
								int subresult = NORESULT;
								int containableIndex = -1;
								for (int i = 0; i < rectArray.length; ++i) {
									//w肵}Xɓ肤`T
									if (isContainable(i, x, y)) {
										Thread.sleep(1);
										if (child != null) {
											child.copy(this);
										} else {
											child = new ShikakuSolverImpl(this);
										}
										
										if (child.changeRect(i, x, y)) {
											int work = child.solve(controller, level + 1, false);
											
											if (work == COMPLATE) {
												if (subresult == COMPLATE) {
													subresult = MULTI;
												} else if (subresult == NORESULT) {
													subresult = COMPLATE;
												}
												
												if (controller.isReturn()) {
													return (resultList.size() == 1) ? COMPLATE : MULTI;
												}
												
												if (containableIndex < 0) {
													containableIndex = i;
												} else {
													containableIndex = -1;
													break;
												}
											} else if (work == MULTI) {
												subresult = MULTI;
												
												if (controller.isReturn()) {
													return (resultList.size() == 1) ? COMPLATE : MULTI;
												}
												
												if (containableIndex < 0) {
													containableIndex = i;
												} else {
													containableIndex = -1;
													break;
												}
											}
										}
									}
								}
								if (subresult == MULTI) {
									if (containableIndex >= 0) {
										//IPȂꍇAŐis
										changeRect(containableIndex, x, y);
										continue mainloop;
									}
								} else if (subresult == COMPLATE) {
									return (resultList.size() == 1) ? COMPLATE : MULTI;
								} else if (subresult == NORESULT) {
									//Ȃ̏ꍇ͂̂܂ܕԂ
									return NORESULT;
								} 
							}
						}
					}
				}
				
				if (deep) {
					//
					int result = NORESULT;
					//ċA
					for (int i = 0; i < rectArray.length; ++i) {
						//w肵}Xɓ肤`T
						if (isContainable(i, firstX, firstY)) {
							Thread.sleep(1);
							if (child != null) {
								child.copy(this);
							} else {
								child = new ShikakuSolverImpl(this);
							}
							
							if (child.changeRect(i, firstX, firstY)) {
								int work = child.solve(controller, level + 1, true);
								if (work == COMPLATE) {
									if (result == COMPLATE) {
										result = MULTI;
									} else if (result == NORESULT) {
										result = COMPLATE;
									}
									
									if (controller.isReturn()) {
										return (resultList.size() == 1) ? COMPLATE : MULTI;
									}
								} else if (work == MULTI) {
									result = MULTI;
									
									if (controller.isReturn()) {
										return (resultList.size() == 1) ? COMPLATE : MULTI;
									}
								}
							}
						}
					}
					return result;
				} else {
					//͂߂
					return MULTI;
				}
			}
		}
	}

	private boolean isContainable(int index, int x, int y) {
		
		Rect rect = rectArray[index];
		
		if (rect.complete) return false;
		
		int left = rect.left;
		int right = rect.right;
		int top = rect.top;
		int bottom = rect.bottom;
		
		if (x < left) {
			left = x;
		} else if (right < x) {
			right = x;
		}
		if (y < top) {
			top = y;
		} else if (bottom < y) {
			bottom = y;
		}
		int width = right - left + 1;
		int height = bottom - top + 1;
		
		if (rect.number > 0) {
			if (width * height > rect.number) {
				return false;
			}
			//TCY擾AӂރTCY݂邱Ƃ`FbN
			boolean notfound = true;
			Size[] sizes = Size.getSizeList(rect.number);
			for (int i = 0; i < sizes.length; ++i) {
				if (width <= sizes[i].width && height <= sizes[i].height) {
					notfound = false;
					break;
				}
			}
			if (notfound) {
				return false;
			}
		} else {
			if (width * height - rect.area > least) {
				return false;
			}
		}
		
		for (y = top; y <= bottom; ++y) {
			for (x = left; x <= right; ++x) {
				int value = board[y * this.width + x];
				if (value != 0 && value != index + 1) {
					return false;
				}
			}
		}
		
		return true;
	}

	private void checkUndecidedRect(int index) {

		Rect rect = rectArray[index];
		if (rect.complete || rect.number >= 0) return;
		
		//
		int left = rect.left;
		int right = rect.right;
		int top = rect.top;
		int bottom = rect.bottom;
		int leftMin = getLeftMin(left, top, bottom);
		int rightMax = getRightMax(right, top, bottom);
		int topMin = getTopMin(top, left, right);
		int bottomMax = getBottomMax(bottom, left, right);
		//݂̖ʐ
		int baseWidth = right - left + 1;
		int baseHeight = bottom - top + 1;
		//܂͍ɃtO𗧂Ă
		int incArea = 0;
		for (int x = left - 1; x >= leftMin; --x) {
			incArea += baseHeight;
			if (incArea <= least) {
				for (int y = top; y <= bottom; ++y) {
					//`FbN{[h̍XV
					updateCheckboard(index, x, y);
				}
			} else {
				break;
			}
		}
		//͉E
		incArea = 0;
		for (int x = right + 1; x <= rightMax; ++x) {
			incArea += baseHeight;
			if (incArea <= least) {
				for (int y = top; y <= bottom; ++y) {
					//`FbN{[h̍XV
					updateCheckboard(index, x, y);
				}
			} else {
				break;
			}
		}
		//͏㑤
		incArea = 0;
		for (int y = top - 1; y >= topMin; --y) {
			incArea += baseWidth;
			if (incArea <= least) {
				for (int x = left; x <= right; ++x) {
					//`FbN{[h̍XV
					updateCheckboard(index, x, y);
				}
			} else {
				break;
			}
		}
		//͉
		incArea = 0;
		for (int y = bottom + 1; y <= bottomMax; ++y) {
			incArea += baseWidth;
			if (incArea <= least) {
				for (int x = left; x <= right; ++x) {
					//`FbN{[h̍XV
					updateCheckboard(index, x, y);
				}
			} else {
				break;
			}
		}
		//
		int currentTopMin = topMin;
		int currentWidth = baseWidth;
		for (int x = left - 1; x >= leftMin; --x) {
			++currentWidth;
			incArea = 0;
			for (int y = top - 1; y >= currentTopMin; --y) {
				incArea += currentWidth;
				if (board[y * width + x] == 0 && incArea <= least) {
					//`FbN{[h̍XV
					updateCheckboard(index, x, y);
				} else {
					currentTopMin = y + 1; 
				}
			}
		}
		//E
		currentTopMin = topMin;
		currentWidth = baseWidth;
		for (int x = right + 1; x <= rightMax; ++x) {
			++currentWidth;
			incArea = 0;
			for (int y = top - 1; y >= currentTopMin; --y) {
				incArea += currentWidth;
				if (board[y * width + x] == 0 && incArea <= least) {
					//`FbN{[h̍XV
					updateCheckboard(index, x, y);
				} else {
					currentTopMin = y + 1; 
				}
			}
		}
		//
		int currentBottomMax = bottomMax;
		currentWidth = baseWidth;
		for (int x = left - 1; x >= leftMin; --x) {
			++currentWidth;
			incArea = 0;
			for (int y = bottom + 1; y <= currentBottomMax; ++y) {
				incArea += currentWidth;
				if (board[y * width + x] == 0 && incArea <= least) {
					//`FbN{[h̍XV
					updateCheckboard(index, x, y);
				} else {
					currentBottomMax = y - 1; 
				}
			}
		}
		//E
		currentBottomMax = bottomMax;
		currentWidth = baseWidth;
		for (int x = right + 1; x <= rightMax; ++x) {
			++currentWidth;
			incArea = 0;
			for (int y = bottom + 1; y <= currentBottomMax; ++y) {
				incArea += currentWidth;
				if (board[y * width + x] == 0 && incArea <= least) {
					//`FbN{[h̍XV
					updateCheckboard(index, x, y);
				} else {
					currentBottomMax = y - 1; 
				}
			}
		}
	}
	
	private void updateCheckboard(int index, int x, int y) {

		int workindex = y * width + x;
		int work = checkboard[workindex];
		
		if (work == 0) {
			checkboard[workindex] = index + 1;
		} else if (work > 0) {
			if (work != index + 1) {
				checkboard[workindex] = -1;
			}
		} else {
			--checkboard[workindex];
		}
	}

	private int checkRect(int index) {

		Rect rect = rectArray[index];
		if (rect.complete) return 0;
		if (rect.number < 0) return 0;
		//
		int left = rect.left;
		int right = rect.right;
		int top = rect.top;
		int bottom = rect.bottom;
		int leftMin = getLeftMin(left, top, bottom);
		int rightMax = getRightMax(right, top, bottom);
		int topMin = getTopMin(top, left, right);
		int bottomMax = getBottomMax(bottom, left, right);
		
		//ɑΉ`̃p^[擾܂
		//LȂĂႭȂĂԂ̃XgɂȂĂ܂
		Size[] sizes = Size.getSizeList(rect.number);
		//ϏW쐬܂
		boolean find = false;
		int newLeft = 0;
		int newRight = 0;
		int newTop = 0;
		int newBottom = 0;
		
		for (int i = 0; i < sizes.length; ++i) {
			Size size = sizes[i];
			//悤ɂȂ܂ŃXLbv
			if (size.height > (bottomMax - topMin + 1)) {
				continue;
			}
			//ȂȂbreak
			if (size.width > (rightMax - leftMin + 1)) {
				break;
			}
			//݂̍ȂȂbreak
			if (size.height < (bottom - top + 1)) {
				break;
			}
			//݂̕Ȃ̂̓XLbv
			if (size.width < (right - left + 1)) {
				continue;
			}
			//ׂẴp^[ɓĂ͂߂
			//ŷƂ肤͈͂߂
			//y̍ŏ̒lFtopMin  bottom - size.height + 1  max
			//y̍ő̒lFtop  bottomMax - size.height + 1  min
			int minX = Math.max(leftMin, right - size.width + 1);
			int maxX = Math.min(left, rightMax - size.width + 1);
			int minY = Math.max(topMin, bottom - size.height + 1);
			int maxY = Math.min(top, bottomMax - size.height + 1);
			for (int startY = minY; startY <= maxY; ++startY) {
				for (int startX = minX; startX <= maxX; ++startX) {
					boolean checksize = true;
					
					checksize:
					for (int y = startY; y < startY + size.height; ++y) {
						if (top <= y && y <= bottom) {
							continue;
						}
						for (int x = startX; x < startX + size.width; ++x) {
							if (left <= x && x <= right) {
								continue;
							}
							
							if (board[y * width + x] != 0) {
								checksize = false;
								break checksize;
							}
						}
					}
					
					if (checksize) {
						if (find) {
							//ϏWXV
							if (newLeft < startX) newLeft = startX;
							if (newRight > startX + size.width - 1) newRight = startX + size.width - 1;
							if (newTop < startY) newTop = startY;
							if (newBottom > startY + size.height - 1) newBottom = startY + size.height - 1;
							
							//ŐVTCŶ݂̂Ɠꂾ֐o
							if (check && newLeft == left && newRight == right && newTop == top && newBottom == bottom) {
								return 0;
							}
						} else {
							//ϏW
							find = true;
							newLeft = startX;
							newRight = startX + size.width - 1;
							newTop = startY;
							newBottom = startY + size.height - 1;
						}
						if (!check && (least == 0 || undecidedCount != 0)) {
							//`FbN{[hXV
							for (int y = startY; y < startY + size.height; ++y) {
								for (int x = startX; x < startX + size.width; ++x) {
									//`FbN{[h̍XV
									updateCheckboard(index, x, y);
								}
							}
						}
					}
				}
			}
		}
		
		if (find) {
			//ŐVTCŶ݂̂Ɠꂾ֐o
			if (newLeft == left && newRight == right && newTop == top && newBottom == bottom) {
				return 0;
			}
			//`̃TCYg傷
			changeRect(index, rect, newLeft, newRight, newTop, newBottom);
			return 1;
		}
		
		return -1;
	}
	
	private int getLeftMin(int left, int top, int bottom) {
		while (left > 0) {
			--left;
			for (int y = top; y <= bottom; ++y) {
				if (board[y * width + left] != 0) {
					return left + 1;
				}
			}
		}
		return left;
	}
	
	private int getRightMax(int right, int top, int bottom) {
		while (right < width - 1) {
			++right;
			for (int y = top; y <= bottom; ++y) {
				if (board[y * width + right] != 0) {
					return right - 1;
				}
			}
		}
		return right;
	}
	
	private int getTopMin(int top, int left, int right) {
		while (top > 0) {
			--top;
			for (int x = left; x <= right; ++x) {
				if (board[top * width + x] != 0) {
					return top + 1;
				}
			}
		}
		return top;
	}
	
	private int getBottomMax(int bottom, int left, int right) {
		while (bottom < height - 1) {
			++bottom;
			for (int x = left; x <= right; ++x) {
				if (board[bottom * width + x] != 0) {
					return bottom - 1;
				}
			}
		}
		return bottom;
	}
	
	private void changeRect(int index, Rect rect, int left, int right, int top, int bottom) {
		
		rect = rect.change(left, right, top, bottom);
		rectArray[index] = rect;
		history.add(rect);
		
		for (int y = top; y <= bottom; ++y) {
			for (int x = left; x <= right; ++x) {
				board[y * width + x] = index + 1;
			}
		}
	}
	
	private boolean changeRect(int index, int x, int y) {
		
		Rect rect = rectArray[index];
		if (rect.number < 0) {
			least += rect.area;
		}
		
		rect = rect.change(x, y);
		
		rectArray[index] = rect;
		history.add(rect);
		
		if (rect.number < 0) {
			least -= rect.area;
		} else if (rect.area > rect.number) {
			return false;
		}
		
		int right = rect.right;
		int bottom = rect.bottom;
		
		for (y = rect.top; y <= bottom; ++y) {
			for (x = rect.left; x <= right; ++x) {
				int work = y * width + x;
				int value = board[work];
				if (value == 0) {
					board[y * width + x] = index + 1;
				} else if (value != index + 1) {
					return false;
				}
			}
		}
		
		return true;
	}

	public void changeRectNumber(int index, int number) {

		Rect rect = rectArray[index];
		
		if (rect.number < 0 && number > 0) {
			--undecidedCount;
		}
		rectArray[index] = rect.change(number);
	}

	/**
	 * 
	 * @return
	 * @see pencilbox.shikaku.solver.ShikakuSolver#getResult()
	 */
	public ShikakuResult getResult() {
		return new ShikakuResult(rectArray, (Rect[])history.toArray(new Rect[0]));
	}
	
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		for (int y = 0; y < height; ++y) {
			for (int x = 0; x < width; ++x) {
				int value = board[y * width + x];
				if (value == 0) {
					buffer.append("....");
				} else {
					buffer.append(value);
					buffer.append('(');
					buffer.append(rectArray[value - 1].number);
					buffer.append(')');
				}
				buffer.append('\t');
			}
			buffer.append('\n');
		}
		buffer.append('\n');
		for (int y = 0; y < height; ++y) {
			for (int x = 0; x < width; ++x) {
				int value = checkboard[y * width + x];
				if (value == 0) {
					buffer.append('.');
				} else {
					buffer.append(value);
				}
				buffer.append('\t');
			}
			buffer.append('\n');
		}		
		return buffer.toString();
	}

	public int getBoard(int x, int y) {
		return board[y * width + x];
	}
}
